//SpiralePlus_201d.js
// 27.12.13 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//DESCRIPTION:Zeichnet eine Spirale

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

// testen, ob ein Dokument geffnet ist
if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// die Version speichern
var appVers = (app.version[0])*1;

// die Namen der fixen Farbfelder und des Objektformats definieren
noColor    = "[None]";
regisColor = "[Registration]";
paperColor = "[Paper]";
blackColor = "[Black]";
objLabel   = "Object Style";

// die Sprache des Programms speichern
var curLang = (app.locale)*1;

// die Namen der Farbfelder vorbereiten (in FR und DE)
if (curLang   == 1279477362) { // = Franzsisch
	noColor      = "[Sans]";
	regisColor   = "[Registration]";
	paperColor   = "[Papier]";
	blackColor   = "[Noir]";
	if (appVers == 4) {
		noColor    = "[Aucun]";
		regisColor = "[Registration]";
	}
	objLabel     = "Style d'objet";
}
else if (curLang == 1279477613) { // = Deutsch
	noColor      = "[Ohne]";
	regisColor   = "[Passermarken]";
	paperColor   = "[Papier]";
	blackColor   = "[Schwarz]";
	if (appVers == 4) {
		noColor    = "[Keine]";
		regisColor = "[Passkreuze]";
	}
	objLabel   = "Objektformat";
	if (appVers < 7) {
		objLabel   = "Objektstil";
	}
}

// das aktuelle Dokument
var curDoc = app.documents[0];

// die Farbfelder des Dokuments
allSwatches = curDoc.swatches;

// die Funktion aufrufen, welche die gespeicherten Vorgaben einliest
var allPrefs = getPrefs();
ck01 = ck02 = ck03 = ck04 = ck05 = ck06 = ck07 = 0;
if (allPrefs != "") {
	var prefVal = allPrefs.split("\n");
	var oCol = prefVal[0];
	if      (oCol == "Black") { oCol = blackColor; }
	else if (oCol == "Paper") { oCol = paperColor; }
	else if (oCol == "Registration") { oName = regisColor; }
	else if (oCol == "None")  { oCol = noColor; }
	strW = prefVal[1]*1;
	strT = prefVal[2]*1;
	objS = prefVal[3];
	rb00 = prefVal[4]*1;
	if (rb00 == 0) {
		ck01 = 1;
	}
	else if (rb00 == 1) {
		ck02 = 1;
	}
	else if (rb00 == 2) {
		ck03 = 1;
	}
	else if (rb00 == 3) {
		ck04 = 1;
	}
	else {
		ck05 = 1;
	}
	staP = prefVal[5]*1;
	endP = prefVal[6]*1;
	sctN = prefVal[7]*1;
	rb01 = prefVal[8]*1;
	if (rb01 == 0) {
		ck06 = 1;
	}
	else {
		ck07 = 1;
	}
	oRge = prefVal[9];
}
else {
	// wenn die Prferenzen-Datei nicht gefunden wurde
	// dann auf die Vorgabenwerte zurckgreifen
	oCol = blackColor;
	strW = 1;
	strT = 100;
	objS = "";
	oSty = 0;
	ck01 = 1;
	ck02 = 0;
	ck03 = 0;
	ck04 = 0;
	ck05 = 0;
	staP = 1;
	endP = 85;
	sctN = 0;
	ck06 = 1;
	ck07 = 0;
	oRge = "10-20, 30-40";
}

// die Funktion aufrufen, welche die Liste der Farbfelder vorbereitet
var oldColor = getColorList(oCol);
var oldCol   = oldColor[0];
var oInd     = oldColor[1];

// die Funktion aufrufen, welche die Objektformate auflistet
objStyleNames = getObjectStyleNames();
objStyleInd = 0;
for (var n=0; n<objStyleNames.length; n++) {
	if (objStyleNames[n] == objS) {
		objStyleInd = n;
		break;
	}
}

// die Unterteilungsoptionen
sectProps = new Array ("An einem Stck", "Einzelne Viertelbogen", "Zwei Bogen, eine Lcke", "Unregelmssig"); 

// die Funktion aufrufen, welche den Dialog zeigt und das Ergebnis zurckgibt
var anArray  = displayDialog();
var sColor   = anArray[0];
var strW     = anArray[1];
var strT     = anArray[2];
var objInd   = anArray[3];
var objStyle = anArray[4];
var distDec  = anArray[5];
var startVal = anArray[6];
var stopVal  = anArray[7];
var sectInd  = anArray[8];
var dirDec   = anArray[9];

// die vorbereiteten Arrays der Anker- und Anfasserpunkte
if (distDec == 0) { // gleichmssige Abstnde der Konturen
	var max1 = 84;
	var max2 = 85;
	if (dirDec == 0) { // = im Uhrzeigersinn
		var pathArrays = [[[107, 105.619], [107, 107], [107, 108.381]], [[105.881, 109.5], [104.5, 109.5], [103.119, 109.5]], 
		[[102, 108.381], [102, 107], [102, 104.239]], [[104.239, 102], [107, 102], [109.761, 102]], 
		[[112, 104.239], [112, 107], [112, 111.142]], [[108.642, 114.5], [104.5, 114.5], [100.358, 114.5]], 
		[[97, 111.142], [97, 107], [97, 101.477]], [[101.477, 97], [107, 97], [112.523, 97]], 
		[[117, 101.477], [117, 107], [117, 113.904]], [[111.404, 119.5], [104.5, 119.5], [97.596, 119.5]], 
		[[92, 113.904], [92, 107], [92, 98.716]], [[98.716, 92], [107, 92], [115.284, 92]], 
		[[122, 98.716], [122, 107], [122, 116.665]], [[114.165, 124.5], [104.5, 124.5], [94.835, 124.5]], 
		[[87, 116.665], [87, 107], [87, 95.954]], [[95.954, 87], [107, 87], [118.046, 87]], 
		[[127, 95.954], [127, 107], [127, 119.426]], [[116.926, 129.5], [104.5, 129.5], [92.074, 129.5]], 
		[[82, 119.426], [82, 107], [82, 93.193]], [[93.193, 82], [107, 82], [120.807, 82]], 
		[[132, 93.193], [132, 107], [132, 122.188]], [[119.688, 134.5], [104.5, 134.5], [89.312, 134.5]], 
		[[77, 122.188], [77, 107], [77, 90.431]], [[90.431, 77], [107, 77], [123.569, 77]], 
		[[137, 90.431], [137, 107], [137, 124.949]], [[122.449, 139.5], [104.5, 139.5], [86.551, 139.5]], 
		[[72, 124.949], [72, 107], [72, 87.67]], [[87.67, 72], [107, 72], [126.33, 72]], 
		[[142, 87.67], [142, 107], [142, 127.711]], [[125.211, 144.5], [104.5, 144.5], [83.789, 144.5]], 
		[[67, 127.711], [67, 107], [67, 84.909]], [[84.909, 67], [107, 67], [129.091, 67]], 
		[[147, 84.909], [147, 107], [147, 130.472]], [[127.972, 149.5], [104.5, 149.5], [81.028, 149.5]], 
		[[62, 130.472], [62, 107], [62, 82.147]], [[82.147, 62], [107, 62], [131.853, 62]], 
		[[152, 82.147], [152, 107], [152, 133.234]], [[130.734, 154.5], [104.5, 154.5], [78.266, 154.5]], 
		[[57, 133.234], [57, 107], [57, 79.386]], [[79.386, 57], [107, 57], [134.614, 57]], 
		[[157, 79.386], [157, 107], [157, 135.995]], [[133.495, 159.5], [104.5, 159.5], [75.505, 159.5]], 
		[[52, 135.995], [52, 107], [52, 76.624]], [[76.624, 52], [107, 52], [137.376, 52]], 
		[[162, 76.624], [162, 107], [162, 138.756]], [[136.256, 164.5], [104.5, 164.5], [72.744, 164.5]], 
		[[47, 138.756], [47, 107], [47, 73.863]], [[73.863, 47], [107, 47], [140.137, 47]], 
		[[167, 73.863], [167, 107], [167, 141.518]], [[139.018, 169.5], [104.5, 169.5], [69.982, 169.5]], 
		[[42, 141.518], [42, 107], [42, 71.101]], [[71.101, 42], [107, 42], [142.899, 42]], 
		[[172, 71.101], [172, 107], [172, 144.279]], [[141.779, 174.5], [104.5, 174.5], [67.221, 174.5]], 
		[[37, 144.279], [37, 107], [37, 68.34]], [[68.34, 37], [107, 37], [145.66, 37]], 
		[[177, 68.34], [177, 107], [177, 147.041]], [[144.541, 179.5], [104.5, 179.5], [64.459, 179.5]], 
		[[32, 147.041], [32, 107], [32, 65.579]], [[65.579, 32], [107, 32], [148.421, 32]], 
		[[182, 65.579], [182, 107], [182, 149.802]], [[147.302, 184.5], [104.5, 184.5], [61.698, 184.5]], 
		[[27, 149.802], [27, 107], [27, 62.817]], [[62.817, 27], [107, 27], [151.183, 27]], 
		[[187, 62.817], [187, 107], [187, 152.563]], [[150.063, 189.5], [104.5, 189.5], [58.937, 189.5]], 
		[[22, 152.563], [22, 107], [22, 60.056]], [[60.056, 22], [107, 22], [153.944, 22]], 
		[[192, 60.056], [192, 107], [192, 155.325]], [[152.825, 194.5], [104.5, 194.5], [56.175, 194.5]], 
		[[17, 155.325], [17, 107], [17, 57.294]], [[57.294, 17], [107, 17], [156.706, 17]], 
		[[197, 57.294], [197, 107], [197, 158.086]], [[155.586, 199.5], [104.5, 199.5], [53.414, 199.5]], 
		[[12, 158.086], [12, 107], [12, 54.533]], [[54.533, 12], [107, 12], [159.467, 12]], 
		[[202, 54.533], [202, 107], [202, 160.848]], [[158.348, 204.5], [104.5, 204.5], [50.652, 204.5]], 
		[[7, 160.848], [7, 107], [7, 51.772]], [[51.772, 7], [107, 7], [162.228, 7]], 
		[[207, 51.772], [207, 107], [207, 163.609]], [[161.109, 209.5], [104.5, 209.5], [47.891, 209.5]], 
		[[2, 163.609], [2, 107], [2, 49.01]], [[49.01, 2], [107, 2], [164.99, 2]], [[212, 49.01], [212, 107], [212, 164.99]]];;
	}
	else { // = gegen den Uhrzeigersinn
		var pathArrays = [[[107, 105.881], [107, 104.5], [107, 103.119]], [[105.881, 102], [104.5, 102], [103.119, 102]], 
		[[102, 103.119], [102, 104.5], [102, 107.261]], [[104.239, 109.5], [107, 109.5], [109.761, 109.5]], 
		[[112, 107.261], [112, 104.5], [112, 100.358]], [[108.642, 97], [104.5, 97], [100.358, 97]], 
		[[97, 100.358], [97, 104.5], [97, 110.023]], [[101.477, 114.5], [107, 114.5], [112.523, 114.5]], 
		[[117, 110.023], [117, 104.5], [117, 97.596]], [[111.404, 92], [104.5, 92], [97.596, 92]], 
		[[92, 97.596], [92, 104.5], [92, 112.784]], [[98.716, 119.5], [107, 119.5], [115.284, 119.5]], 
		[[122, 112.784], [122, 104.5], [122, 94.835]], [[114.165, 87], [104.5, 87], [94.835, 87]], 
		[[87, 94.835], [87, 104.5], [87, 115.546]], [[95.954, 124.5], [107, 124.5], [118.046, 124.5]], 
		[[127, 115.546], [127, 104.5], [127, 92.074]], [[116.926, 82], [104.5, 82], [92.074, 82]], 
		[[82, 92.074], [82, 104.5], [82, 118.307]], [[93.193, 129.5], [107, 129.5], [120.807, 129.5]], 
		[[132, 118.307], [132, 104.5], [132, 89.312]], [[119.688, 77], [104.5, 77], [89.312, 77]], 
		[[77, 89.312], [77, 104.5], [77, 121.069]], [[90.431, 134.5], [107, 134.5], [123.569, 134.5]], 
		[[137, 121.069], [137, 104.5], [137, 86.551]], [[122.449, 72], [104.5, 72], [86.551, 72]], 
		[[72, 86.551], [72, 104.5], [72, 123.83]], [[87.67, 139.5], [107, 139.5], [126.33, 139.5]], 
		[[142, 123.83], [142, 104.5], [142, 83.789]], [[125.211, 67], [104.5, 67], [83.789, 67]], 
		[[67, 83.789], [67, 104.5], [67, 126.591]], [[84.909, 144.5], [107, 144.5], [129.091, 144.5]], 
		[[147, 126.591], [147, 104.5], [147, 81.028]], [[127.972, 62], [104.5, 62], [81.028, 62]], 
		[[62, 81.028], [62, 104.5], [62, 129.353]], [[82.147, 149.5], [107, 149.5], [131.853, 149.5]], 
		[[152, 129.353], [152, 104.5], [152, 78.266]], [[130.734, 57], [104.5, 57], [78.266, 57]], 
		[[57, 78.266], [57, 104.5], [57, 132.114]], [[79.386, 154.5], [107, 154.5], [134.614, 154.5]], 
		[[157, 132.114], [157, 104.5], [157, 75.505]], [[133.495, 52], [104.5, 52], [75.505, 52]], 
		[[52, 75.505], [52, 104.5], [52, 134.876]], [[76.624, 159.5], [107, 159.5], [137.376, 159.5]], 
		[[162, 134.876], [162, 104.5], [162, 72.744]], [[136.256, 47], [104.5, 47], [72.744, 47]], 
		[[47, 72.744], [47, 104.5], [47, 137.637]], [[73.863, 164.5], [107, 164.5], [140.137, 164.5]], 
		[[167, 137.637], [167, 104.5], [167, 69.982]], [[139.018, 42], [104.5, 42], [69.982, 42]], 
		[[42, 69.982], [42, 104.5], [42, 140.399]], [[71.101, 169.5], [107, 169.5], [142.899, 169.5]], 
		[[172, 140.399], [172, 104.5], [172, 67.221]], [[141.779, 37], [104.5, 37], [67.221, 37]], 
		[[37, 67.221], [37, 104.5], [37, 143.16]], [[68.34, 174.5], [107, 174.5], [145.66, 174.5]], 
		[[177, 143.16], [177, 104.5], [177, 64.459]], [[144.541, 32], [104.5, 32], [64.459, 32]], 
		[[32, 64.459], [32, 104.5], [32, 145.921]], [[65.579, 179.5], [107, 179.5], [148.421, 179.5]], 
		[[182, 145.921], [182, 104.5], [182, 61.698]], [[147.302, 27], [104.5, 27], [61.698, 27]], 
		[[27, 61.698], [27, 104.5], [27, 148.683]], [[62.817, 184.5], [107, 184.5], [151.183, 184.5]], 
		[[187, 148.683], [187, 104.5], [187, 58.937]], [[150.063, 22], [104.5, 22], [58.937, 22]], 
		[[22, 58.937], [22, 104.5], [22, 151.444]], [[60.056, 189.5], [107, 189.5], [153.944, 189.5]], 
		[[192, 151.444], [192, 104.5], [192, 56.175]], [[152.825, 17], [104.5, 17], [56.175, 17]], 
		[[17, 56.175], [17, 104.5], [17, 154.206]], [[57.294, 194.5], [107, 194.5], [156.706, 194.5]], 
		[[197, 154.206], [197, 104.5], [197, 53.414]], [[155.586, 12], [104.5, 12], [53.414, 12]], 
		[[12, 53.414], [12, 104.5], [12, 156.967]], [[54.533, 199.5], [107, 199.5], [159.467, 199.5]], 
		[[202, 156.967], [202, 104.5], [202, 50.652]], [[158.348, 7], [104.5, 7], [50.652, 7]], 
		[[7, 50.652], [7, 104.5], [7, 159.728]], [[51.772, 204.5], [107, 204.5], [162.228, 204.5]], 
		[[207, 159.728], [207, 104.5], [207, 47.891]], [[161.109, 2], [104.5, 2], [47.891, 2]], 
		[[2, 47.891], [2, 104.5], [2, 162.49]], [[49.01, 209.5], [107, 209.5], [164.99, 209.5]], [[212, 162.49], [212, 104.5], [212, 46.51]]];;
	}
}
else if (distDec == 1) { // Abstnde der Konturen innen enger (1 mm)
	var max1 = 38;
	var max2 = 39;
	if (dirDec == 0) { // = im Uhrzeigersinn
		var pathArrays = [[[101, 107.052], [101, 106.5], [101, 105.948]], [[101.448, 105.5], [102, 105.5], [102.552, 105.5]], 
		[[103, 105.948], [103, 106.5], [103, 107.881]], [[101.881, 109], [100.5, 109], [99.119, 109]], 
		[[98, 107.881], [98, 106.5], [98, 104.015]], [[100.015, 102], [102.5, 102], [104.985, 102]], 
		[[107, 104.015], [107, 106.5], [107, 110.366]], [[103.866, 113.5], [100, 113.5], [96.134, 113.5]], 
		[[93, 110.366], [93, 106.5], [93, 100.977]], [[97.477, 96.5], [103, 96.5], [108.523, 96.5]], 
		[[113, 100.977], [113, 106.5], [113, 113.956]], [[106.956, 120], [99.5, 120], [92.044, 120]], 
		[[86, 113.956], [86, 106.5], [86, 96.835]], [[93.835, 89], [103.5, 89], [113.165, 89]], 
		[[121, 96.835], [121, 106.5], [121, 118.65]], [[111.15, 128.5], [99, 128.5], [86.85, 128.5]], 
		[[77, 118.65], [77, 106.5], [77, 91.588]], [[89.088, 79.5], [104, 79.5], [118.912, 79.5]], 
		[[131, 91.588], [131, 106.5], [131, 124.449]], [[116.449, 139], [98.5, 139], [80.551, 139]], 
		[[66, 124.449], [66, 106.5], [66, 85.237]], [[83.237, 68], [104.5, 68], [125.763, 68]], 
		[[143, 85.237], [143, 106.5], [143, 131.353]], [[122.853, 151.5], [98, 151.5], [73.147, 151.5]], 
		[[53, 131.353], [53, 106.5], [53, 77.781]], [[76.281, 54.5], [105, 54.5], [133.719, 54.5]], 
		[[157, 77.781], [157, 106.5], [157, 139.361]], [[130.361, 166], [97.5, 166], [64.639, 166]], 
		[[38, 139.361], [38, 106.5], [38, 69.221]], [[68.221, 39], [105.5, 39], [142.779, 39]], 
		[[173, 69.221], [173, 106.5], [173, 148.474]], [[138.974, 182.5], [97, 182.5], [55.026, 182.5]], 
		[[21, 148.474], [21, 106.5], [21, 59.556]], [[59.056, 21.5], [106, 21.5], [152.944, 21.5]], 
		[[191, 59.556], [191, 106.5], [191, 158.691]], [[148.691, 201], [96.5, 201], [44.309, 201]], 
		[[2, 158.691], [2, 106.5], [2, 48.786]], [[48.786, 2], [106.5, 2], [164.214, 2]], [[211, 48.786], [211, 106.5], [211, 164.214]]];
	}
	else { // = gegen den Uhrzeigersinn
		var pathArrays = [[[101, 95.948], [101, 96.5], [101, 97.052]], [[101.448, 97.5], [102, 97.5], [102.552, 97.5]], 
		[[103, 97.052], [103, 96.5], [103, 95.119]], [[101.881, 94], [100.5, 94], [99.119, 94]], 
		[[98, 95.119], [98, 96.5], [98, 98.985]], [[100.015, 101], [102.5, 101], [104.985, 101]], 
		[[107, 98.985], [107, 96.5], [107, 92.634]], [[103.866, 89.5], [100, 89.5], [96.134, 89.5]], 
		[[93, 92.634], [93, 96.5], [93, 102.023]], [[97.477, 106.5], [103, 106.5], [108.523, 106.5]], 
		[[113, 102.023], [113, 96.5], [113, 89.044]], [[106.956, 83], [99.5, 83], [92.044, 83]], 
		[[86, 89.044], [86, 96.5], [86, 106.165]], [[93.835, 114], [103.5, 114], [113.165, 114]], 
		[[121, 106.165], [121, 96.5], [121, 84.35]], [[111.15, 74.5], [99, 74.5], [86.85, 74.5]], 
		[[77, 84.35], [77, 96.5], [77, 111.412]], [[89.088, 123.5], [104, 123.5], [118.912, 123.5]], 
		[[131, 111.412], [131, 96.5], [131, 78.551]], [[116.449, 64], [98.5, 64], [80.551, 64]], 
		[[66, 78.551], [66, 96.5], [66, 117.763]], [[83.237, 135], [104.5, 135], [125.763, 135]], 
		[[143, 117.763], [143, 96.5], [143, 71.647]], [[122.853, 51.5], [98, 51.5], [73.147, 51.5]], 
		[[53, 71.647], [53, 96.5], [53, 125.219]], [[76.281, 148.5], [105, 148.5], [133.719, 148.5]], 
		[[157, 125.219], [157, 96.5], [157, 63.639]], [[130.361, 37], [97.5, 37], [64.639, 37]], 
		[[38, 63.639], [38, 96.5], [38, 133.779]], [[68.221, 164], [105.5, 164], [142.779, 164]], 
		[[173, 133.779], [173, 96.5], [173, 54.526]], [[138.974, 20.5], [97, 20.5], [55.026, 20.5]], 
		[[21, 54.526], [21, 96.5], [21, 143.444]], [[59.056, 181.5], [106, 181.5], [152.944, 181.5]], 
		[[191, 143.444], [191, 96.5], [191, 44.309]], [[148.691, 2], [96.5, 2], [44.309, 2]], 
		[[2, 44.309], [2, 96.5], [2, 154.214]], [[48.786, 201], [106.5, 201], [164.214, 201]], [[211, 154.214], [211, 96.5], [211, 38.786]]];
	}
}
else if (distDec == 2) { // Abstnde der Konturen innen enger (2 mm)
	var max1 = 30;
	var max2 = 31;
	if (dirDec == 0) { // = im Uhrzeigersinn
		var pathArrays = [[[100, 108.552], [100, 108], [100, 107.448]], [[100.448, 107], [101, 107], [101.552, 107]], 
		[[102, 107.448], [102, 108], [102, 109.105]], [[101.105, 110], [100, 110], [98.895, 110]], 
		[[98, 109.105], [98, 108], [98, 105.791]], [[99.791, 104], [102, 104], [104.209, 104]], 
		[[106, 105.791], [106, 108], [106, 111.866]], [[102.866, 115], [99, 115], [95.134, 115]], 
		[[92, 111.866], [92, 108], [92, 101.925]], [[96.925, 97], [103, 97], [109.075, 97]], 
		[[114, 101.925], [114, 108], [114, 116.837]], [[106.837, 124], [98, 124], [89.163, 124]], 
		[[82, 116.837], [82, 108], [82, 95.85]], [[91.85, 86], [104, 86], [116.15, 86]], 
		[[126, 95.85], [126, 108], [126, 124.016]], [[113.016, 137], [97, 137], [80.984, 137]], 
		[[68, 124.016], [68, 108], [68, 87.565]], [[84.565, 71], [105, 71], [125.435, 71]], 
		[[142, 87.565], [142, 108], [142, 133.405]], [[121.405, 154], [96, 154], [70.595, 154]], 
		[[50, 133.405], [50, 108], [50, 77.072]], [[75.072, 52], [106, 52], [136.928, 52]], 
		[[162, 77.072], [162, 108], [162, 145.003]], [[132.003, 175], [95, 175], [57.997, 175]], 
		[[28, 145.003], [28, 108], [28, 64.37]], [[63.37, 29], [107, 29], [150.63, 29]], 
		[[186, 64.37], [186, 108], [186, 158.81]], [[144.81, 200], [94, 200], [43.19, 200]], 
		[[2, 158.81], [2, 108], [2, 49.458]], [[49.458, 2], [108, 2], [166.542, 2]], [[214, 49.458], [214, 108], [214, 166.542]]];
	}
	else { // = gegen den Uhrzeigersinn
		var pathArrays = [[[100, 93.448], [100, 94], [100, 94.552]], [[100.448, 95], [101, 95], [101.552, 95]], 
		[[102, 94.552], [102, 94], [102, 92.895]], [[101.105, 92], [100, 92], [98.895, 92]], 
		[[98, 92.895], [98, 94], [98, 96.209]], [[99.791, 98], [102, 98], [104.209, 98]], 
		[[106, 96.209], [106, 94], [106, 90.134]], [[102.866, 87], [99, 87], [95.134, 87]], 
		[[92, 90.134], [92, 94], [92, 100.075]], [[96.925, 105], [103, 105], [109.075, 105]], 
		[[114, 100.075], [114, 94], [114, 85.163]], [[106.837, 78], [98, 78], [89.163, 78]], 
		[[82, 85.163], [82, 94], [82, 106.15]], [[91.85, 116], [104, 116], [116.15, 116]], 
		[[126, 106.15], [126, 94], [126, 77.984]], [[113.016, 65], [97, 65], [80.984, 65]], 
		[[68, 77.984], [68, 94], [68, 114.435]], [[84.565, 131], [105, 131], [125.435, 131]], 
		[[142, 114.435], [142, 94], [142, 68.595]], [[121.405, 48], [96, 48], [70.595, 48]], 
		[[50, 68.595], [50, 94], [50, 124.928]], [[75.072, 150], [106, 150], [136.928, 150]], 
		[[162, 124.928], [162, 94], [162, 56.997]], [[132.003, 27], [95, 27], [57.997, 27]], 
		[[28, 56.997], [28, 94], [28, 137.63]], [[63.37, 173], [107, 173], [150.63, 173]], 
		[[186, 137.63], [186, 94], [186, 43.19]], [[144.81, 2], [94, 2], [43.19, 2]], 
		[[2, 43.19], [2, 94], [2, 152.542]], [[49.458, 200], [108, 200], [166.542, 200]], [[214, 152.542], [214, 94], [214, 35.458]]];
	}
}
else if (distDec == 3) { // Abstnde der Konturen innen weiter (1 mm)
	var max1 = 38;
	var max2 = 39;
	if (dirDec == 0) { // = im Uhrzeigersinn
		var pathArrays = [[[110, 131.113], [110, 122], [110, 112.887]], [[117.387, 105.5], [126.5, 105.5], [135.613, 105.5]], 
		[[143, 112.887], [143, 122], [143, 136.636]], [[131.136, 148.5], [116.5, 148.5], [101.864, 148.5]], 
		[[90, 136.636], [90, 122], [90, 102.118]], [[106.118, 86], [126, 86], [145.882, 86]], 
		[[162, 102.118], [162, 122], [162, 146.853]], [[141.853, 167], [117, 167], [92.147, 167]], 
		[[72, 146.853], [72, 122], [72, 92.453]], [[95.953, 68.5], [125.5, 68.5], [155.047, 68.5]], 
		[[179, 92.453], [179, 122], [179, 155.966]], [[151.466, 183.5], [117.5, 183.5], [83.534, 183.5]], 
		[[56, 155.966], [56, 122], [56, 83.892]], [[86.892, 53], [125, 53], [163.108, 53]], 
		[[194, 83.892], [194, 122], [194, 163.974]], [[159.974, 198], [118, 198], [76.026, 198]], 
		[[42, 163.974], [42, 122], [42, 76.437]], [[78.937, 39.5], [124.5, 39.5], [170.063, 39.5]], 
		[[207, 76.437], [207, 122], [207, 170.877]], [[167.377, 210.5], [118.5, 210.5], [69.623, 210.5]], 
		[[30, 170.877], [30, 122], [30, 70.085]], [[72.085, 28], [124, 28], [175.915, 28]], 
		[[218, 70.085], [218, 122], [218, 176.676]], [[173.676, 221], [119, 221], [64.324, 221]], 
		[[20, 176.676], [20, 122], [20, 64.839]], [[66.339, 18.5], [123.5, 18.5], [180.661, 18.5]], 
		[[227, 64.839], [227, 122], [227, 181.371]], [[178.871, 229.5], [119.5, 229.5], [60.129, 229.5]], 
		[[12, 181.371], [12, 122], [12, 60.696]], [[61.696, 11], [123, 11], [184.304, 11]], 
		[[234, 60.696], [234, 122], [234, 184.96]], [[182.96, 236], [120, 236], [57.04, 236]], 
		[[6, 184.96], [6, 122], [6, 57.659]], [[58.159, 5.5], [122.5, 5.5], [186.841, 5.5]], 
		[[239, 57.659], [239, 122], [239, 187.446]], [[185.946, 240.5], [120.5, 240.5], [55.054, 240.5]], 
		[[2, 187.446], [2, 122], [2, 55.726]], [[55.726, 2], [122, 2], [188.274, 2]], [[242, 55.726], [242, 122], [242, 188.826]]];
	}
	else { // = gegen den Uhrzeigersinn
		var pathArrays = [[[110, 111.387], [110, 120.5], [110, 129.613]], [[117.387, 137], [126.5, 137], [135.613, 137]], 
		[[143, 129.613], [143, 120.5], [143, 105.864]], [[131.136, 94], [116.5, 94], [101.864, 94]], 
		[[90, 105.864], [90, 120.5], [90, 140.382]], [[106.118, 156.5], [126, 156.5], [145.882, 156.5]], 
		[[162, 140.382], [162, 120.5], [162, 95.647]], [[141.853, 75.5], [117, 75.5], [92.147, 75.5]], 
		[[72, 95.647], [72, 120.5], [72, 150.047]], [[95.953, 174], [125.5, 174], [155.047, 174]], 
		[[179, 150.047], [179, 120.5], [179, 86.534]], [[151.466, 59], [117.5, 59], [83.534, 59]], 
		[[56, 86.534], [56, 120.5], [56, 158.608]], [[86.892, 189.5], [125, 189.5], [163.108, 189.5]], 
		[[194, 158.608], [194, 120.5], [194, 78.526]], [[159.974, 44.5], [118, 44.5], [76.026, 44.5]], 
		[[42, 78.526], [42, 120.5], [42, 166.063]], [[78.937, 203], [124.5, 203], [170.063, 203]], 
		[[207, 166.063], [207, 120.5], [207, 71.623]], [[167.377, 32], [118.5, 32], [69.623, 32]],
		 [[30, 71.623], [30, 120.5], [30, 172.415]], [[72.085, 214.5], [124, 214.5], [175.915, 214.5]], 
		 [[218, 172.415], [218, 120.5], [218, 65.824]], [[173.676, 21.5], [119, 21.5], [64.324, 21.5]], 
		 [[20, 65.824], [20, 120.5], [20, 177.661]], [[66.339, 224], [123.5, 224], [180.661, 224]], 
		 [[227, 177.661], [227, 120.5], [227, 61.129]], [[178.871, 13], [119.5, 13], [60.129, 13]], 
		 [[12, 61.129], [12, 120.5], [12, 181.804]], [[61.696, 231.5], [123, 231.5], [184.304, 231.5]], 
		 [[234, 181.804], [234, 120.5], [234, 57.54]], [[182.96, 6.5], [120, 6.5], [57.04, 6.5]], 
		 [[6, 57.54], [6, 120.5], [6, 184.841]], [[58.159, 237], [122.5, 237], [186.841, 237]], 
		 [[239, 184.841], [239, 120.5], [239, 55.054]], [[185.946, 2], [120.5, 2], [55.054, 2]], 
		 [[2, 55.054], [2, 120.5], [2, 186.774]], [[55.726, 240.5], [122, 240.5], [188.274, 240.5]], [[242, 186.774], [242, 120.5], [242, 53.674]]];
	}
}
else if (distDec == 4) { // Abstnde der Konturen innen weiter (2 mm)
	var max1 = 28;
	var max2 = 29;
	if (dirDec == 0) { // = im Uhrzeigersinn
		var pathArrays = [[[130, 113.163], [130, 122], [130, 130.837]], [[122.837, 138], [114, 138], [105.163, 138]], 
		[[98, 130.837], [98, 122], [98, 105.431]], [[111.431, 92], [128, 92], [144.569, 92]], 
		[[158, 105.431], [158, 122], [158, 145.748]], [[138.748, 165], [115, 165], [91.252, 165]], 
		[[72, 145.748], [72, 122], [72, 91.624]], [[96.624, 67], [127, 67], [157.376, 67]], 
		[[182, 91.624], [182, 122], [182, 158.451]], [[152.451, 188], [116, 188], [79.549, 188]], 
		[[50, 158.451], [50, 122], [50, 80.026]], [[84.026, 46], [126, 46], [167.974, 46]], 
		[[202, 80.026], [202, 122], [202, 168.944]], [[163.944, 207], [117, 207], [70.056, 207]], 
		[[32, 168.944], [32, 122], [32, 70.638]], [[73.638, 29], [125, 29], [176.362, 29]], 
		[[218, 70.638], [218, 122], [218, 177.228]], [[173.228, 222], [118, 222], [62.772, 222]], 
		[[18, 177.228], [18, 122], [18, 63.458]], [[65.458, 16], [124, 16], [182.542, 16]], 
		[[230, 63.458], [230, 122], [230, 183.304]], [[180.304, 233], [119, 233], [57.696, 233]], 
		[[8, 183.304], [8, 122], [8, 58.487]], [[59.487, 7], [123, 7], [186.513, 7]], 
		[[238, 58.487], [238, 122], [238, 187.17]], [[185.17, 240], [120, 240], [54.83, 240]], 
		[[2, 187.17], [2, 122], [2, 55.726]], [[55.726, 2], [122, 2], [188.274, 2]], [[242, 55.726], [242, 122], [242, 188.274]]];
	}
	else { // = gegen den Uhrzeigersinn
		var pathArrays = [[[130, 128.837], [130, 120], [130, 111.163]], [[122.837, 104], [114, 104], [105.163, 104]], 
		[[98, 111.163], [98, 120], [98, 136.569]], [[111.431, 150], [128, 150], [144.569, 150]], 
		[[158, 136.569], [158, 120], [158, 96.252]], [[138.748, 77], [115, 77], [91.252, 77]], 
		[[72, 96.252], [72, 120], [72, 150.376]], [[96.624, 175], [127, 175], [157.376, 175]], 
		[[182, 150.376], [182, 120], [182, 83.549]], [[152.451, 54], [116, 54], [79.549, 54]], 
		[[50, 83.549], [50, 120], [50, 161.974]], [[84.026, 196], [126, 196], [167.974, 196]], 
		[[202, 161.974], [202, 120], [202, 73.056]], [[163.944, 35], [117, 35], [70.056, 35]], 
		[[32, 73.056], [32, 120], [32, 171.362]], [[73.638, 213], [125, 213], [176.362, 213]], 
		[[218, 171.362], [218, 120], [218, 64.772]], [[173.228, 20], [118, 20], [62.772, 20]], 
		[[18, 64.772], [18, 120], [18, 178.542]], [[65.458, 226], [124, 226], [182.542, 226]], 
		[[230, 178.542], [230, 120], [230, 58.696]], [[180.304, 9], [119, 9], [57.696, 9]], 
		[[8, 58.696], [8, 120], [8, 183.513]], [[59.487, 235], [123, 235], [186.513, 235]], 
		[[238, 183.513], [238, 120], [238, 54.83]], [[185.17, 2], [120, 2], [54.83, 2]], 
		[[2, 54.83], [2, 120], [2, 186.274]], [[55.726, 240], [122, 240], [188.274, 240]], [[242, 186.274], [242, 120], [242, 53.726]]];
	}
}

// Masseinheiten, Linealursprung und Nullpunkt speichern
hM = curDoc.viewPreferences.horizontalMeasurementUnits;
vM = curDoc.viewPreferences.verticalMeasurementUnits;
rO = curDoc.viewPreferences.rulerOrigin;
zP = curDoc.zeroPoint;

// Einstellungen ndern
curDoc.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.verticalMeasurementUnits = MeasurementUnits.millimeters;
curDoc.viewPreferences.rulerOrigin = RulerOrigin.PAGE_ORIGIN;
curDoc.zeroPoint = [0,0];

// die Sperrung der aktiven Ebene prfen
var isLocked = false;
if (app.activeWindow.activeLayer.locked == true) {
	app.activeWindow.activeLayer.locked = false;
	isLocked = true;
}

// der Abstands-Array
var distArr = new Array ("gleichmssig", "enger 1", "enger 2", "weiter 1", "weiter 2");
// der Laufrichtungs-Array
var dirArr = new Array ("im Uhrzeigersinn", "gegen den Uhrzeigersinn");

// den definitiven Array zusammensetzen (von Start- bis Stop-Ankerpunkt)
if (sectInd == 0) { // = "An einem Stck"
	var defArr  = new Array ();
	for (var n=startVal-1; n<stopVal; n++) {
		defArr.push(pathArrays[n]);
	}
	// einen Linienrahmen erzeugen
	var newPath = app.activeWindow.activePage.graphicLines.add();
	// dem neuen Pfad den definitiven Array zuweisen
	newPath.paths[0].entirePath = defArr;
	// dem Pfad die Attribute zuweisen
	if (objInd > 0) { // mit Objektformat
		newPath.appliedObjectStyle = curDoc.objectStyles.item(objStyle);
	}
	else { // ohne Objektformat
		newPath.appliedObjectStyle = curDoc.objectStyles.item(0);
		newPath.properties = {strokeWeight:strW, strokeColor:sColor, strokeTint:strT,
	   strokeAlignment:StrokeAlignment.CENTER_ALIGNMENT, endCap:EndCap.ROUND_END_CAP};
	}
	// den Eintrag ins Etikett vornehmen
	newPath.label = "Konturabstnde: " + distArr[distDec] + "\rStart-Ankerpunkt: " + startVal + "\rStop-Ankerpunkt: " + stopVal + "\rRichtung: " + dirArr[dirDec];
	// die Einstellungsdatei fr die unbenutzte Option "Unregelmssig" ergnzen
	writeResult("a", "\n" + oRge);
}
else if (sectInd == 1) { // = "Einzelne Viertelbogen"
	for (var n=startVal-1; n<stopVal-1; n++) {
		var defArr  = new Array ();
		defArr.push(pathArrays[n]);
		defArr.push(pathArrays[n+1]);
		// einen Linienrahmen erzeugen
		var newPath = app.activeWindow.activePage.graphicLines.add();
		// dem neuen Pfad den definitiven Array zuweisen
		newPath.paths[0].entirePath = defArr;
		// dem Pfad die Attribute zuweisen
		if (objInd > 0) { // mit Objektformat
			newPath.appliedObjectStyle = curDoc.objectStyles.item(objStyle);
		}
		else { // ohne Objektformat
			newPath.appliedObjectStyle = curDoc.objectStyles.item(0);
			newPath.properties = {strokeWeight:strW, strokeColor:sColor, strokeTint:strT,
		   strokeAlignment:StrokeAlignment.CENTER_ALIGNMENT, endCap:EndCap.ROUND_END_CAP};
		}
		// den Eintrag ins Etikett vornehmen
		newPath.label = "Konturabstnde: " + distArr[distDec] + "\rStart-Ankerpunkt: " + (n+1) + "\rStop-Ankerpunkt: " + (n+2) + "\rRichtung: " + dirArr[dirDec];
	}
	// die Einstellungsdatei fr die unbenutzte Option "Unregelmssig" ergnzen
	writeResult("a", "\n" + oRge);
}
else if (sectInd == 2) { // = "Zwei Bogen, eine Lcke"
	var ctr = startVal-1;
	var nSects = Math.ceil((stopVal-startVal)/3);
	for (var n=0; n<nSects; n++) {
		var defArr  = new Array ();
		defArr.push(pathArrays[ctr]);
		ctr++;
		defArr.push(pathArrays[ctr]);
		ctr++
		defArr.push(pathArrays[ctr]);
		ctr++;
		// einen Linienrahmen erzeugen
		var newPath = app.activeWindow.activePage.graphicLines.add();
		// dem neuen Pfad den definitiven Array zuweisen
		try {
			newPath.paths[0].entirePath = defArr;
			// dem Pfad die Attribute zuweisen
			if (objInd > 0) { // mit Objektformat
				newPath.appliedObjectStyle = curDoc.objectStyles.item(objStyle);
			}
			else { // ohne Objektformat
				newPath.appliedObjectStyle = curDoc.objectStyles.item(0);
				newPath.properties = {strokeWeight:strW, strokeColor:sColor, strokeTint:strT,
			   strokeAlignment:StrokeAlignment.CENTER_ALIGNMENT, endCap:EndCap.ROUND_END_CAP};
			}
		}
		catch (e) {
			try {
				newPath.remove();
			}
			catch (e) {
			}
		}
		// den Eintrag ins Etikett vornehmen
		newPath.label = "Konturabstnde: " + distArr[distDec] + "\rStart-Ankerpunkt: " + startVal + "\rStop-Ankerpunkt: " + stopVal + "\rRichtung: " + dirArr[dirDec];
		// die Einstellungsdatei fr die unbenutzte Option "Unregelmssig" ergnzen
		writeResult("a", "\n" + oRge);
	}
}
else if (sectInd == 3) { // = "Unregelmssig"
	// einen Prompt zur Eingabe der Bereiche anzeigen
	var tmpRange = prompt ("Bereiche der Ankerpunkte:\n(z.B. 16-21, 23-29, 31-46, 50-69)", oRge);
	if (tmpRange == null) {
		reStoreSettings();
		writeResult("a", "\n" + oRge);
		exit();
	}
	// Leerschlge entfernen
	defRange = tmpRange.replace(/ /g, "");
	// die Eingabe prfen
	if (defRange == "") {
		alert ("Die Eingabe ist leer.\rBitte nochmals.", "Stop");
		writeResult("a", "\n" + oRge);
		reStoreSettings();
		exit();
	}
	else if (defRange == "undefined") {
		alert ("Die Eingabe ist nicht definiert.\rBitte nochmals.", "Stop");
		writeResult("a", "\n" + oRge);
		reStoreSettings();
		exit();
	}
	else {
		writeResult("a", "\n" + tmpRange);
		// alle Bereiche
		var allRanges = defRange.split(",");
		// eine Schleife durch die Bereiche
		var startVals = new Array ();
		var stopVals  = new Array ();
		for (var r=0; r<allRanges.length; r++) {
			var curRange = allRanges[r].split("-");
			if (curRange.length == 1) {
				alert ("Der Bereich " + (r+1) + " hat nur *einen* Wert.\rBitte nochmals.", "Stop");
				reStoreSettings();
				exit();
			}
			else if (curRange.length > 2) {
				alert ("Der Bereich " + (r+1) + " hat *" + curRange.length + "* Werte.\rBitte nochmals.", "Stop");
				reStoreSettings();
				exit();
			}
			// Start- und Stopwert prfen
			var aStart = curRange[0];
			for (var a=0; a<aStart.length; a++) {
				if ("0123456789".indexOf(aStart[a]) == -1) {
					alert ("Bereich " + (r+1) + ", Wert 1 = ungltig ( " + aStart + " )\rBitte nochmals.", "Stop");
					reStoreSettings();
					exit();
				}
			}
			var aStop = curRange[1];
			for (var z=0; z<aStop.length; z++) {
				if ("0123456789".indexOf(aStop[z]) == -1) {
					alert ("Bereich " + (r+1) + ", Wert 2 = ungltig ( " + aStop + " )\rBitte nochmals.", "Stop");
					reStoreSettings();
					exit();
				}
			}
			aStart = aStart*1;
			aStop  = aStop*1;
			if (aStart == aStop) {
				alert ("Bereich " + (r+1) + ": beide Werte sind gleich ( " + curRange + " )\rBitte nochmals.", "Stop");
				reStoreSettings();
				exit();
			}
			if (aStart == 0) {
				alert ("Bereich " + (r+1) + ": Der Startwert kann nicht Null sein.\rBitte nochmals.", "Stop");
				reStoreSettings();
				exit();
			}
			else if (aStart > max1) {
				alert ("Der Startwert darf nicht grsser als " + max1 + " sein.\rBitte nochmals.", "Stop");
				reStoreSettings();
				exit();
			}
			if (aStop == 0) {
				alert ("Bereich " + (r+1) + ": Der Stopwert kann nicht Null sein.\rBitte nochmals.", "Stop");
				reStoreSettings();
				exit();
			}
			else if (aStop > max2) {
				alert ("Der Stopwert darf nicht grsser als " + max2 + " sein.\rBitte nochmals.", "Stop");
				reStoreSettings();
				exit();
			}
			startVals.push(aStart);
			stopVals.push(aStop);
		}
		// eine Schleife durch die Werte
		for (var a=0; a<startVals.length; a++) {
			var startVal = startVals[a];
			var stopVal  = stopVals[a];
			if (startVal > stopVal) {
				var tmpVal = startVal;
				startVal = stopVal;
				stopVal  = tmpVal;
			}
			var defArr  = new Array ();
			for (var n=startVal-1; n<stopVal; n++) {
				defArr.push(pathArrays[n]);
			}
			// einen Linienrahmen erzeugen
			var newPath = app.activeWindow.activePage.graphicLines.add();
			// dem neuen Pfad den definitiven Array zuweisen
			newPath.paths[0].entirePath = defArr;
			// dem Pfad die Attribute zuweisen
			if (objInd > 0) { // mit Objektformat
				newPath.appliedObjectStyle = curDoc.objectStyles.item(objStyle);
			}
			else { // ohne Objektformat
				newPath.appliedObjectStyle = curDoc.objectStyles.item(0);
				newPath.properties = {strokeWeight:strW, strokeColor:sColor, strokeTint:strT,
			   strokeAlignment:StrokeAlignment.CENTER_ALIGNMENT, endCap:EndCap.ROUND_END_CAP};
			}
			// den Eintrag ins Etikett vornehmen
			newPath.label = "Konturabstnde: " + distArr[distDec] + "\rStart-Ankerpunkt: " + startVal + "\rStop-Ankerpunkt: " + stopVal + "\rRichtung: " + dirArr[dirDec];
		}
	}
}

// die Funktion zum Zurcksetzen der Einstellungen aufrufen
reStoreSettings();

// das Ende der Aktion verknden
alert ("Fertig.", "");


////////////////////////////// die Funktionen  ////////////////////////////////////////////////////

// die Funktion, welche die Informationen vorbereitet /////////////////////////////////////////////
function getPrefs() {
	var allPrefs = "";
	// die Datei lesen, welche die gespeicherten Werte enthlt
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiralePlus201.txt");
	}
	else {
		var f = new File("~/Library/Preferences/SpiralePlus201.txt");
	}
	var fileIsOpen = f.open("r");
	if (fileIsOpen) {
		try {
			allPrefs = f.read();
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
	return allPrefs;
}

// die Funktion, welche die Liste der Farbfelder vorbereitet //////////////////////////////////////
function getColorList(oName) {
	// prfen, ob die Vorgabefarbe existiert
	if (oName != noColor && oName != regisColor && oName != paperColor && oName != blackColor) {
		try {
			curDoc.swatches.itemByName(oName).name;
		}
		catch (e) {
			oName = blackColor;
		}
	}
	// die Liste der Farben zusammenstellen;
	// "None", "Paper", "Black" und "Registration" umbenennen;
	// die Position der Vorgabefarbe feststellen
	var colorList = new Array();
	for (var i=0; i<allSwatches.length; i++) {
		cName = allSwatches.item(i).name;
		if (cName == "None") {
			cName = noColor;
		}
		else if (cName == "Paper") {
			cName = paperColor;
		}
		else if (cName == "Black") {
			cName = blackColor;
		}
		else if (cName == "Registration") {
			cName = regisColor;
		}
		if (oName == cName) {
			oIndex = i;
		}
		colorList.push(cName);
	}
	return [colorList, oIndex];
}

// die Funktion, welche die Objektformatnamen auflistet ///////////////////////////////////////////
function getObjectStyleNames() {
	var allObjStyles = curDoc.objectStyles.everyItem().name;
	var nStyles = allObjStyles.length;
	var objStyleNames = new Array (allObjStyles[0]);
	for (var i=0; i<nStyles; i++) {
		curStyle = allObjStyles[i];
		if (curStyle.indexOf("[") == -1) {
			objStyleNames.push(curStyle);
		}
	}
	return objStyleNames;
}

// den Dialog vorbereiten und anzeigen ////////////////////////////////////////////////////////////
function displayDialog() {
	try {
		app.dialogs.everyItem().destroy();
	}
	catch (e) {
	}
	var labelWidth = 136;
	var menuWidth  = 130;
	var fieldWidth =  36;
	var aDialog = app.dialogs.add({name:"SpiralePlus"});
	with (aDialog) {
		with (dialogColumns.add()) {
			with (dialogRows.add()) {
			staticTexts.add({staticLabel:"Entweder Farbe + Strke + Tonwert ..."});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Kontur-Farbe:", minWidth:60});
						staticTexts.add({staticLabel:" ", minWidth:120});
					}
					var selColor = dropdowns.add({stringList:oldCol, selectedIndex:oInd, minWidth:menuWidth});
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Kontur-Strke:", minWidth:labelWidth-10});
						var weightField = realEditboxes.add({editValue:strW, minimumValue:0.1, maximumValue:99, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"pt", minWidth:16});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Kontur-Tonwert:", minWidth:labelWidth-10});
						var tintField = realEditboxes.add({editValue:strT, minimumValue:1, maximumValue:100, minWidth:fieldWidth});
						staticTexts.add({staticLabel:"%", minWidth:12});
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"... *oder* ein " + objLabel});
				staticTexts.add({staticLabel:" "});
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:objLabel + ":", minWidth:60});
						staticTexts.add({staticLabel:" ", minWidth:120});
					}
					var objectStyleDropdown = dropdowns.add({stringList:objStyleNames, selectedIndex:objStyleInd, minWidth:menuWidth});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Abstnde der Konturen:", minWidth:120});
						staticTexts.add({staticLabel:" ", minWidth:60});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:16});
						with(distButtons = radiobuttonGroups.add()){
							radiobuttonControls.add({staticLabel:"gleichmssig", checkedState:ck01});
							radiobuttonControls.add({staticLabel:"innen zunehmend enger 1", checkedState:ck02});
							radiobuttonControls.add({staticLabel:"innen zunehmend enger 2", checkedState:ck03});
							radiobuttonControls.add({staticLabel:"innen zunehmend weiter 1", checkedState:ck04});
							radiobuttonControls.add({staticLabel:"innen zunehmend weiter 2", checkedState:ck05});
						}
					}
				}
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Start-Ankerpunkt:", minWidth:labelWidth});
				var startField = integerEditboxes.add({editValue:staP, minimumValue:1, maximumValue:84, minWidth:fieldWidth});
			}
			with (dialogRows.add()) {
				staticTexts.add({staticLabel:"Stop-Ankerpunkt:", minWidth:labelWidth});
				var stopField = integerEditboxes.add({editValue:endP, minimumValue:2, maximumValue:85, minWidth:fieldWidth});
			}
			with (dialogRows.add()) {
				with (dialogColumns.add()) {
					staticTexts.add({staticLabel:"Max. Zahl Ankerpunkte:  gleich = 85"});
					staticTexts.add({staticLabel:"enger 1 = 39  |  weiter 1 = 39"});
					staticTexts.add({staticLabel:"enger 2 = 31  |  weiter 2 = 29"});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Zusammensetzung:", minWidth:60});
						staticTexts.add({staticLabel:" ", minWidth:86});
					}
					var sectorDropdown = dropdowns.add({stringList:sectProps, selectedIndex:sctN, minWidth:menuWidth});
				}
			}
			with (borderPanels.add()) {
				with (dialogColumns.add()) {
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:"Laufrichtung:", minWidth:60});
						staticTexts.add({staticLabel:" ", minWidth:126});
					}
					with (dialogRows.add()) {
						staticTexts.add({staticLabel:" ", minWidth:16});
						with(dirButtons = radiobuttonGroups.add()){
							radiobuttonControls.add({staticLabel:"im Uhrzeigersinn", checkedState:ck06});
							radiobuttonControls.add({staticLabel:"gegen den Uhrzeigersinn", checkedState:ck07});
						}
					}
				}
			}
		}
	}
	if(aDialog.show() == true) {
		// die Eingaben auswerten
		colIndex = selColor.selectedIndex;
		sColor = curDoc.swatches[colIndex].name;
		if      (sColor == blackColor) { sColor = "Black"; }
		else if (sColor == paperColor) { sColor = "Paper"; }
		else if (sColor == regisColor) { sColor = "Registration"; }
		else if (sColor == noColor)    { sColor = "None"; }
		strWght = weightField.editValue;
		strTint = tintField.editValue;
		var objInd = objectStyleDropdown.selectedIndex;
		var objectStyle = objStyleNames[objectStyleDropdown.selectedIndex];
		var distDec  = distButtons.selectedButton;
		var startVal = startField.editValue;
		var stopVal  = stopField.editValue;
		var sectInd  = sectorDropdown.selectedIndex;
		var dirDec   = dirButtons.selectedButton;
		// den Dialog entfernen
		aDialog.destroy();
		// wenn die Konturstrke leer ist, einen Vorgabewert zuweisen
		if (strWght == "") {
			strWght = 1;
		}
		// wenn der Kontur-Tonwert leer ist, einen Vorgabewert zuweisen
		if (strTint == "") {
			strTint = 100;
		}
		// die neue Vorgabenliste
		var prefsList = new Array (sColor, strWght, strTint, objectStyle, distDec, startVal, stopVal, sectInd, dirDec);
		// in eine Textkette verwandeln
		var prefString = prefsList.join("\n");
		// zur Funktion schicken, welche das Ergebnis in eine Datei schreibt
		writeResult("w", prefString);
		// die Werte austauschen, wenn der Startwert grsser ist als der Stopwert 
		if (startVal > stopVal) {
			var tmpVal = startVal;
			startVal = stopVal;
			stopVal  = tmpVal;
		}
		else if (startVal == stopVal) {
			alert ("Spassvogel!\rStart- und Stopwert sind identisch.\rBitte nochmals.", "Stop");
			exit();
		}
		// prfen, ob die Werte zur gewhlten Option passen
		if (sectInd < 3) {
			var corrStart = corrStop = false;
			if (distDec == 1) {
				if (startVal > 38) { startVal = 38; corrStart = true; }
				if (stopVal  > 39) { stopVal  = 39; corrStop  = true; }
				if (corrStart && corrStop) {
					alert ("Werte korrigiert: Start = 38, Stop = 39", "Achtung");
				}
				else if (corrStart) {
					alert ("Start-Wert auf 38 korrigiert.", "Achtung");
				}
				else if (corrStop) {
					alert ("Stop-Wert auf 39 korrigiert.", "Achtung");
				}
			}
			else if (distDec == 2) {
				if (startVal > 30) { startVal = 30; corrStart = true; }
				if (stopVal  > 31) { stopVal  = 31; corrStop  = true; }
				if (corrStart && corrStop) {
					alert ("Werte korrigiert: Start = 30, Stop = 41", "Achtung");
				}
				else if (corrStart) {
					alert ("Start-Wert auf 30 korrigiert.", "Achtung");
				}
				else if (corrStop) {
					alert ("Stop-Wert auf 31 korrigiert.", "Achtung");
				}
			}
			else if (distDec == 3) {
				if (startVal > 38) { startVal = 38; corrStart = true; }
				if (stopVal  > 39) { stopVal  = 39; corrStop  = true; }
				if (corrStart && corrStop) {
					alert ("Werte korrigiert: Start = 38, Stop = 39", "Achtung");
				}
				else if (corrStart) {
					alert ("Start-Wert auf 38 korrigiert.", "Achtung");
				}
				else if (corrStop) {
					alert ("Stop-Wert auf 39 korrigiert.", "Achtung");
				}
			}
			else if (distDec == 4) {
				if (startVal > 28) { startVal = 28; corrStart = true; }
				if (stopVal  > 29) { stopVal  = 29; corrStop  = true; }
				if (corrStart && corrStop) {
					alert ("Werte korrigiert: Start = 28, Stop = 29", "Achtung");
				}
				else if (corrStart) {
					alert ("Start-Wert auf 28 korrigiert.", "Achtung");
				}
				else if (corrStop) {
					alert ("Stop-Wert auf 29 korrigiert.", "Achtung");
				}
			}
			if (corrStart == true || corrStop == true) {
				// nach einer nderung erneut die Liste zusammensetzen und in die Datei schreiben
				var prefsList = new Array (sColor, strWght, strTint, objectStyle, distDec, startVal, stopVal, sectInd, dirDec);
				var prefString = prefsList.join("\n");
				writeResult("w", prefString);
			}
		}
		// das Ergebnis zum Aufruf zurckschicken
		return [sColor, strWght, strTint, objInd, objectStyle, distDec, startVal, stopVal, sectInd, dirDec];
	}
	else {
		// wenn "Abbrechen", den Dialog entfernen und die Ausfhrung abbrechen
		aDialog.destroy();
		exit();
	}
}

// das Ergebnis in eine Datei schreiben ///////////////////////////////////////////////////////////
function writeResult(rwMode, curPrefs) {
	if ($.os.slice(0,7) == "Windows") {
		var tempFolder = Folder.temp;
		var f = File(tempFolder + "/SpiralePlus201.txt");
	}
	else {
		var f = File("~/Library/Preferences/SpiralePlus201.txt");
	}
	var fileIsOpen = f.open(rwMode);
	if (fileIsOpen) {
		try {
			f.write(curPrefs);
			f.close();
		}
		catch (e) {
			try {
				f.close();
			}
			catch (e) {
			}
		}
	}
}

// eventuell genderte Einstellungen zurcksetzen /////////////////////////////////////////////////
function reStoreSettings() {
	// Masseinheiten, Linealursprung und Nullpunkt zurcksetzen
	curDoc.viewPreferences.horizontalMeasurementUnits = hM;
	curDoc.viewPreferences.verticalMeasurementUnits = vM;
	curDoc.viewPreferences.rulerOrigin = rO;
	curDoc.zeroPoint = zP;
	// die Sperrung der aktiven Ebene wiederherstellen (falls notwendig)
	if (isLocked) {
		app.activeWindow.activeLayer.locked = true;
	}
}